#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
const float pi = 3.14159;

class box {
   public: 
      box() {};
      box(float h, float w, float l){
         height =h; width = w; length = l;
         }
      float volume () {return height * width * length; }
   protected:
      float read_height () {return height;}
      float read_width ()  {return width;}
      float read_length () {return length;}
   private: float height, width, length;
   };
class cylinder {
   public: 
      cylinder () {};
      cylinder (float r, float l){
         radius = r; length = l;
         }
      float volume () { return pi * radius * radius * length; }
   protected:
      float read_radius () {return radius;}
      float read_length () {return length;}
   private: float radius, length;
   };
class railroad_car {
   public: 
      char *serial_number;
      railroad_car () {++counter;} 
      railroad_car (char* input_buffer) {
         ++counter;
         serial_number = new char[strlen(input_buffer) +1];
         strcpy (serial_number, input_buffer);
         } 
      virtual ~railroad_car () {
         cout << "Destroying a railroad car; "
              << --counter << " remain." << endl;
         delete [] serial_number;
         }
      virtual char* short_name () {return "rrc";}
      virtual float capacity ()   { return 0.0;}
   private:
      railroad_car (railroad_car&);
      static int counter;
   };
int railroad_car::counter = 0;

class box_car : public railroad_car, public box {
   public: 
      box_car () : box (10.5, 9.5, 40.0) {} 
      box_car (char* input_buffer) : railroad_car (input_buffer),
                                     box(10.5, 9.5, 40.0) {}
      virtual char* short_name () {return "box";}
      virtual float capacity() {return volume();}
   };
class tank_car : public railroad_car, public cylinder {
   public: 
      tank_car () : cylinder (3.5, 40.0) {} 
      tank_car (char* input_buffer) : railroad_car (input_buffer),
                                      cylinder (3.5, 40.0) {} 
      virtual char* short_name () {return "tnk";}
      virtual float capacity() {return volume();}
   };
class engine :   public railroad_car {
   public: 
      engine () {} 
      engine (char* input_buffer) : railroad_car (input_buffer) {}
      virtual char* short_name () {return "eng";}
   };
class caboose:   public railroad_car {
   public: 
      caboose () {} 
      caboose (char* input_buffer) : railroad_car (input_buffer) {}
      virtual char* short_name () {return "cab";}
   };

railroad_car *train[100];
char input_buffer[100];

enum { eng_code = 'E', box_code = 'B', tnk_code = 'T', cab_code = 'C'};
char extract_car_code (char *input_buffer) {return input_buffer[4];}

void do_analysis (ifstream& car_stream){
   int n, car_count;
   for (car_count = 0; car_stream >> input_buffer; ++car_count) {
      if (car_count > 100) { 
         cerr << "Array overflow in train[n]!" << endl;
         exit (0);
         }
      delete train[car_count];
      switch (extract_car_code (input_buffer)) {
         case eng_code: train[car_count] = new engine(input_buffer);  break;
         case box_code: train[car_count] = new box_car(input_buffer); break;
         case tnk_code: train[car_count] = new tank_car(input_buffer);break;
         case cab_code: train[car_count] = new caboose(input_buffer); break;
         default: cerr << "Car code is unknown!" << endl; 
	          exit (0); 
         }
      }
   for (n = 0; n < car_count; ++n) {
      cout << train[n] -> serial_number << "   "
           << train[n] -> short_name () << "   "
           << train[n] -> capacity ()   << endl;
      }
   }


main () { 
while (1) {
   cout << "Please type the name of a train file." << endl << ": ";
   cin  >> input_buffer;
   ifstream car_stream (input_buffer, ios::in);
   if (!car_stream) { cout << "No such file." << endl; return 0;}
   do_analysis (car_stream);
   car_stream.close ();
   }
}

